# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs

__all__ = [
    'GetReplicationSetResult',
    'AwaitableGetReplicationSetResult',
    'get_replication_set',
    'get_replication_set_output',
]

@pulumi.output_type
class GetReplicationSetResult:
    """
    A collection of values returned by getReplicationSet.
    """
    def __init__(__self__, arn=None, created_by=None, deletion_protected=None, id=None, last_modified_by=None, regions=None, status=None, tags=None):
        if arn and not isinstance(arn, str):
            raise TypeError("Expected argument 'arn' to be a str")
        pulumi.set(__self__, "arn", arn)
        if created_by and not isinstance(created_by, str):
            raise TypeError("Expected argument 'created_by' to be a str")
        pulumi.set(__self__, "created_by", created_by)
        if deletion_protected and not isinstance(deletion_protected, bool):
            raise TypeError("Expected argument 'deletion_protected' to be a bool")
        pulumi.set(__self__, "deletion_protected", deletion_protected)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if last_modified_by and not isinstance(last_modified_by, str):
            raise TypeError("Expected argument 'last_modified_by' to be a str")
        pulumi.set(__self__, "last_modified_by", last_modified_by)
        if regions and not isinstance(regions, list):
            raise TypeError("Expected argument 'regions' to be a list")
        pulumi.set(__self__, "regions", regions)
        if status and not isinstance(status, str):
            raise TypeError("Expected argument 'status' to be a str")
        pulumi.set(__self__, "status", status)
        if tags and not isinstance(tags, dict):
            raise TypeError("Expected argument 'tags' to be a dict")
        pulumi.set(__self__, "tags", tags)

    @property
    @pulumi.getter
    def arn(self) -> str:
        """
        The Amazon Resouce Name (ARN) of the replication set.
        """
        return pulumi.get(self, "arn")

    @property
    @pulumi.getter(name="createdBy")
    def created_by(self) -> str:
        """
        The ARN of the user who created the replication set.
        """
        return pulumi.get(self, "created_by")

    @property
    @pulumi.getter(name="deletionProtected")
    def deletion_protected(self) -> bool:
        """
        If `true`, the last remaining Region in a replication set can’t be deleted.
        """
        return pulumi.get(self, "deletion_protected")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="lastModifiedBy")
    def last_modified_by(self) -> str:
        """
        The ARN of the user who last modified the replication set.
        """
        return pulumi.get(self, "last_modified_by")

    @property
    @pulumi.getter
    def regions(self) -> Sequence['outputs.GetReplicationSetRegionResult']:
        return pulumi.get(self, "regions")

    @property
    @pulumi.getter
    def status(self) -> str:
        """
        The current status of the Region.
        * Valid Values: `ACTIVE` | `CREATING` | `UPDATING` | `DELETING` | `FAILED`
        """
        return pulumi.get(self, "status")

    @property
    @pulumi.getter
    def tags(self) -> Mapping[str, str]:
        """
        All tags applied to the replication set.
        """
        return pulumi.get(self, "tags")


class AwaitableGetReplicationSetResult(GetReplicationSetResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetReplicationSetResult(
            arn=self.arn,
            created_by=self.created_by,
            deletion_protected=self.deletion_protected,
            id=self.id,
            last_modified_by=self.last_modified_by,
            regions=self.regions,
            status=self.status,
            tags=self.tags)


def get_replication_set(tags: Optional[Mapping[str, str]] = None,
                        opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetReplicationSetResult:
    """
    > **NOTE:** The AWS Region specified by a provider must always be one of the Regions specified for the replication set.

    Use this data source to manage a replication set in AWS Systems Manager Incident Manager.

    ## Example Usage

    ### Basic Usage

    <!--Start PulumiCodeChooser -->
    ```python
    import pulumi
    import pulumi_aws as aws

    example = aws.ssmincidents.get_replication_set()
    ```
    <!--End PulumiCodeChooser -->


    :param Mapping[str, str] tags: All tags applied to the replication set.
    """
    __args__ = dict()
    __args__['tags'] = tags
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('aws:ssmincidents/getReplicationSet:getReplicationSet', __args__, opts=opts, typ=GetReplicationSetResult).value

    return AwaitableGetReplicationSetResult(
        arn=pulumi.get(__ret__, 'arn'),
        created_by=pulumi.get(__ret__, 'created_by'),
        deletion_protected=pulumi.get(__ret__, 'deletion_protected'),
        id=pulumi.get(__ret__, 'id'),
        last_modified_by=pulumi.get(__ret__, 'last_modified_by'),
        regions=pulumi.get(__ret__, 'regions'),
        status=pulumi.get(__ret__, 'status'),
        tags=pulumi.get(__ret__, 'tags'))


@_utilities.lift_output_func(get_replication_set)
def get_replication_set_output(tags: Optional[pulumi.Input[Optional[Mapping[str, str]]]] = None,
                               opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetReplicationSetResult]:
    """
    > **NOTE:** The AWS Region specified by a provider must always be one of the Regions specified for the replication set.

    Use this data source to manage a replication set in AWS Systems Manager Incident Manager.

    ## Example Usage

    ### Basic Usage

    <!--Start PulumiCodeChooser -->
    ```python
    import pulumi
    import pulumi_aws as aws

    example = aws.ssmincidents.get_replication_set()
    ```
    <!--End PulumiCodeChooser -->


    :param Mapping[str, str] tags: All tags applied to the replication set.
    """
    ...
